#!/usr/bin/python

import serial
import timeit
import time
import threading
import inv_serialcomm


## START of Main, smtp client

# Plug in your Serial Port with COMXX, 115200,8bit,Par=None,Stopbit 1,
# XonXoff disable, Hardware Handshake RTS/CTS Off
# Enter you SSID, Password and security type -At commands( C1, C2, C3 )
# Add your e-mail address

inv_serialcomm.print_string("Opening Comport")
ser        = serial.Serial('COM9', 115200,bytesize=8,parity='N',stopbits=1, timeout=None,xonxoff=0,rtscts=0)

#Need a Buffer to place incomming data
inv_serialcomm.rxBuffer   = inv_serialcomm.StringBuffer() #a new StringBuffer is made

#Start a thread for receiving data, start thread
inv_serialcomm.print_string("Creating a thread")
inv_serialcomm.exitThread = 0
thread     = threading.Thread(target=inv_serialcomm.read_from_port, args=(ser,))
thread.start()

#Now Write a help command just for testing
inv_serialcomm.print_string("Issuing help command -?")
ser.write("?\r")        # write a string

time.sleep(1)           # delays

#Just report how many char received agter issuing help command
time.sleep(1)                          # delays for 2 seconds
inv_serialcomm.rxBuffer.flush



#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()


#CD must disconnect first
inv_serialcomm.print_string("Disconnect for network - CD")
cmd_string="CD\r"

inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(1)                                  # delays for 1 seconds
#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()


#C1 = Set SSID
inv_serialcomm.print_string("Setting up SSID")
cmd_string="C1=IS2.4\r"
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(1)                                  # delays for 1 seconds
#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Set C2= Pasword, please note carriage ret is not
#part of passphrase
inv_serialcomm.print_string("Setting Passphrase")
cmd_string="C2=IS24KNXit\r"
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(1)                                  # delays for 1 seconds
#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()


#Set Security Type
inv_serialcomm.print_string("Setting Channel Info")
cmd_string="C3=4\r"                            # set Security type 4 WPA2 Mixed
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Set Channel Info
inv_serialcomm.print_string("Setup DHCP")
cmd_string="C4=1\r"                            # Turn on DHCP
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()


#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()


#Join SSID Network
inv_serialcomm.print_string("Joining Netowrk")
cmd_string="C0\r"                              # set ssid
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(10)                                 # delays for 5 seconds


#Signal Strength
inv_serialcomm.print_string("Signal Strgth")
cmd_string="CR\r"                              # Check RSSI
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(1)                                 # delays for 1 second

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()


#Prepate for Opening Socket, TCP Socket
inv_serialcomm.print_string("Opening a TCP Socket")
cmd_string="P1=0\r"                            # set protocol to TCP
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(1)                                 # delays for 1 second

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Set Port Delay 10
inv_serialcomm.print_string("Selecting Port Timeout")
cmd_string="S2=5000\r"                          # Set Send Timeout
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(1)                                 # delays for 5 seconds

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()



#Set Port Number 587
inv_serialcomm.print_string("Selecting SMTP Port Number 587")
cmd_string="P4=587\r"                          # set Port nummber
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(1)                                 # delays for 5 seconds

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Set Remote IP Address 64.136.44.50, FIXME <Use of DNS smtp.netzero.com>
inv_serialcomm.print_string("Set Remote IP Address 64.136.44.50")
cmd_string="P3=64.136.44.50\r"                 # set remote port
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(1)                                 # delays for 5 seconds

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Set Now Connect to Client
inv_serialcomm.print_string("Connecting")
cmd_string="P6=1\r"                            # set ssid
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(15)                                 # delays for 5 seconds

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()


#Say HELO to Remote Server
inv_serialcomm.print_string("HELO mail.inventek.com")
smtp_cmd = "HELO mail.inventek.com\r\n"          # set smtp cmd
pre_cmd  = "%s%d\r" % ('S1=',len(smtp_cmd))    # determine its len
ismtp_cmd= "%s%s" % ('S0\r',smtp_cmd)          # inventek structure
inv_serialcomm.print_string(pre_cmd)           # Print Cmd for reference
inv_serialcomm.print_string(ismtp_cmd)         # Print Cmd for reference
ser.write(pre_cmd)                             # Issue command to serial to Wifi Module
ser.write(ismtp_cmd)                           # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds

#Now Listen from Server
inv_serialcomm.print_string("Retriving Rcved Data")
ser.write("R0\r")                              # Issue command to serial to Wifi Module

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Auth Login
inv_serialcomm.print_string("Authurizing Login")
smtp_cmd = "auth login\r\n"                      # set smtp cmd
pre_cmd  = "%s%d\r" % ('S1=',len(smtp_cmd))      # determine its len
ismtp_cmd= "%s%s" % ('S0\r',smtp_cmd)          # inventek structure
inv_serialcomm.print_string(pre_cmd)           # Print Cmd for reference
inv_serialcomm.print_string(ismtp_cmd)         # Print Cmd for reference
ser.write(pre_cmd)                             # Issue command to serial to Wifi Module
ser.write(ismtp_cmd)                           # Issue command to serial to Wifi Module
time.sleep(5)                                 # delays for 5 seconds

#Now Listen from Server
inv_serialcomm.print_string("Retriving Rcved Data")
ser.write("R0\r")                              # Issue command to serial to Wifi Module


#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Auth Login
inv_serialcomm.print_string("Send Login")
smtp_cmd = "anNtaXRoeDI=\r\n"                      # set login
pre_cmd  = "%s%d\r" % ('S1=',len(smtp_cmd))    # determine its len
ismtp_cmd= "%s%s" % ('S0\r',smtp_cmd)          # inventek structure
inv_serialcomm.print_string(pre_cmd)           # Print Cmd for reference
inv_serialcomm.print_string(ismtp_cmd)         # Print Cmd for reference
ser.write(pre_cmd)                             # Issue command to serial to Wifi Module
ser.write(ismtp_cmd)                           # Issue command to serial to Wifi Module

#Now Listen from Server
inv_serialcomm.print_string("Retriving Rcved Data")
ser.write("R0\r")                              # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Send Password
inv_serialcomm.print_string("Send 64base password")
smtp_cmd = "MnhodGltc2o=\r\n"                    # set ssid
pre_cmd  = "%s%d\r" % ('S1=',len(smtp_cmd))      # determine its len
ismtp_cmd= "%s%s" % ('S0\r',smtp_cmd)          # inventek structure
inv_serialcomm.print_string(pre_cmd)           # Print Cmd for reference
inv_serialcomm.print_string(ismtp_cmd)         # Print Cmd for reference
ser.write(pre_cmd)                             # Issue command to serial to Wifi Module
ser.write(ismtp_cmd)                           # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds

#Now Listen from Server
inv_serialcomm.print_string("Retriving Rcved Data")
ser.write("R0\r")                              # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Send eMail Addr
inv_serialcomm.print_string("mail FROM:<jsmithx2@netzero.com> size=34");
smtp_cmd = "mail FROM:<jsmithx2@netzero.com> size=34\r\n"        # set ssid
pre_cmd  = "%s%d\r" % ('S1=',len(smtp_cmd))      # determine its len
ismtp_cmd= "%s%s" % ('S0\r',smtp_cmd)          # inventek structure
inv_serialcomm.print_string(pre_cmd)           # Print Cmd for reference
inv_serialcomm.print_string(ismtp_cmd)         # Print Cmd for reference
ser.write(pre_cmd)                             # Issue command to serial to Wifi Module
ser.write(ismtp_cmd)                           # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds

#Now Listen from Server
inv_serialcomm.print_string("Retriving Rcved Data")
ser.write("R0\r")                              # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds


#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Send eMail Addr
inv_serialcomm.print_string("rcpt TO:<martint@inventeksys.com>");
smtp_cmd = "rcpt TO:<martint@inventeksys.com>\r\n"
#inv_serialcomm.print_string("rcpt TO:<martint@inventeksys.com>");
#smtp_cmd = "rcpt TO:<martint@inventeksys.com>\r\n"
#inv_serialcomm.print_string("rcpt TO:<stevep@inventeksys.com>");
#smtp_cmd = "rcpt TO:<stevep@inventeksys.com>\r\n"


pre_cmd  = "%s%d\r" % ('S1=',len(smtp_cmd))      # determine its len
ismtp_cmd= "%s%s" % ('S0\r',smtp_cmd)          # inventek structure
inv_serialcomm.print_string(pre_cmd)           # Print Cmd for reference
inv_serialcomm.print_string(ismtp_cmd)         # Print Cmd for reference
ser.write(pre_cmd)                             # Issue command to serial to Wifi Module
ser.write(ismtp_cmd)                           # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds
#Now Listen from Server
inv_serialcomm.print_string("Retriving Rcved Data")
ser.write("R0\r")                              # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds


#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()


inv_serialcomm.print_string("Data")
smtp_cmd = "data\r\n"                    # set ssid
pre_cmd  = "%s%d\r" % ('S1=',len(smtp_cmd))      # determine its len
ismtp_cmd= "%s%s" % ('S0\r',smtp_cmd)          # inventek structure
inv_serialcomm.print_string(pre_cmd)           # Print Cmd for reference
inv_serialcomm.print_string(ismtp_cmd)         # Print Cmd for reference
ser.write(pre_cmd)                             # Issue command to serial to Wifi Module
ser.write(ismtp_cmd)                           # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds
#Now Listen from Server
inv_serialcomm.print_string("Retriving Rcved Data")
ser.write("R0\r")                              # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds


#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

inv_serialcomm.print_string("Test")
smtp_cmd = "This is XYZ 12345 Testing SerialWifi Module using Python Script\r\n"
pre_cmd  = "%s%d\r" % ('S1=',len(smtp_cmd))      # determine its len
ismtp_cmd= "%s%s" % ('S0\r',smtp_cmd)          # inventek structure
inv_serialcomm.print_string(pre_cmd)           # Print Cmd for reference
inv_serialcomm.print_string(ismtp_cmd)         # Print Cmd for reference
ser.write(pre_cmd)                             # Issue command to serial to Wifi Module
ser.write(ismtp_cmd)                           # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds
#Now Listen from Server
inv_serialcomm.print_string("Retriving Rcved Data")
ser.write("R0\r")                              # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds


#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

inv_serialcomm.print_string(".")
pre_cmd  = "%s\r" % ('S1=3')      # determine its len
ismtp_cmd= "%s" % ('S0\r.\r\n')          # inventek structure
inv_serialcomm.print_string(pre_cmd)           # Print Cmd for reference
inv_serialcomm.print_string(ismtp_cmd)         # Print Cmd for reference
ser.write(pre_cmd)                             # Issue command to serial to Wifi Module
ser.write(ismtp_cmd)                           # Issue command to serial to Wifi Module
time.sleep(5)                                  # delays for 5 seconds

#Now Listen from Server
inv_serialcomm.print_string("Retriving Rcved Data")
ser.write("R0\r")                              # Issue command to serial to Wifi Module
time.sleep(10)                                  # delays for 5 seconds

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()

#Set Now Disconnect to Client
inv_serialcomm.print_string("Disconnecting")
cmd_string="P6=0\r"                           # set ssid
inv_serialcomm.print_string(cmd_string)        # Print Cmd for reference
ser.write(cmd_string)                          # Issue command to serial to Wifi Module
time.sleep(1)                                 # delays for 5 seconds

#Pull every thing from Uart Rx buffer and print
inv_serialcomm.print_string(inv_serialcomm.readUARTRxStr())
inv_serialcomm.flushUARTRx()




#Now SSID working, Exit thread and close COM port
inv_serialcomm.exitThread = True
ser.close()

